#Include <File.au3>

#cs

Script to trim empty sound off start and end of sound files.

Script reads file names one by one from a list, and does something in Audacity (beta). 

The format of the list file is just the paths of the sound files to deal with.

#ce

Global $i
Global $part
Global $line
Global $fileopen
Global $fileread
Global $start
Global $numlines
Global $lineread
Global $j
Global $audacity

HotKeySet("{ESC}", "Terminate")

AutoItSetOption ( "WinTitleMatchMode", 2)

$j = 0

$fileopen = FileOpen ("soundfilelist.txt")

$numlines = _FileCountLines("soundfilelist.txt")

MsgBox (0, "Trimsoundfiles v0.1", "Welcome to Trimsoundfiles.  Please consult the readme.txt file before continuing.", 0)

; Run Audacity first before running the script

WinActivate ("Audacity", "")
WinWaitActive ("Audacity", "")

$audacity = WinGetHandle ("Audacity", "")

For $i = 1 to $numlines

Sleep ("200")

$lineread = FileReadLine ("soundfilelist.txt", $i)

$part = StringSplit ($lineread, @TAB, 1)
; $part[1] = openfile
; $part[2] = savefile

WinActivate ($audacity, "")
WinWaitActive ($audacity, "")

; First clear any tracks

Send ("!t")
Sleep ("1000")
Send ("v")
Sleep ("1000")

; WinActivate ($audacity, "")
; WinWaitActive ($audacity, "")

Send ("^+i")
Sleep ("1000")
ClipPut ($part[1])
Sleep ("100")
Send ("^a")
Sleep ("1000")
Send ("^v")
Sleep ("1000")
Send ("{ENTER}")
Sleep ("1000")

; WinActivate ($audacity, "")
; WinWaitActive ($audacity, "")

; Then trim it from sounds

Send ("^a")
Sleep ("1000")
Send ("!c")
Sleep ("1000")
Send ("t")
Sleep ("1000")
Send ("{ENTER}")
Sleep ("1000")
Send ("{ENTER}")
Sleep ("1000")

; WinActivate ($audacity, "")
; WinWaitActive ($audacity, "")

; Then export it (save it)

Send ("^a")
Sleep ("1000")
Send ("!f")
Sleep ("1000")
Send ("e")
Sleep ("1000")
ClipPut ($part[2])
Sleep ("100")
Send ("^a")
Sleep ("1000")
Send ("^v")
Sleep ("1000")
Send ("{ENTER}")
Sleep ("1000")
Send ("{ENTER}")
Sleep ("1000")

; WinActivate ($audacity, "")
; WinWaitActive ($audacity, "")

; Then clear the track again

Send ("!t")
Sleep ("1000")
Send ("v")
Sleep ("1000")

; MsgBox (0, "", "asdf", 0)

Next

Func Terminate()
    Exit
EndFunc

